# Profile data migration

To make it easier to collect data to a Profile, Batch has added two automatic ways to migrate old installation's data on a Profile:

* User will be automatically identified (logged-in) if he had a Batch `custom_user_id` set on the local storage.
* User natives (language/region) and custom data will be automatically migrated to a Profile.

These migrations are triggered when your application on the dashboard is attached to a Project. Concretely this mean that there's two possible scenarios:

* Your app is running on the SDK v1 and is already attached to a Project : migrations will be triggered on the first start running on SDK v2.
* Your app is running on the SDK v2 but not attached to a Project: migrations will be triggered on the first start after your app is attached to a project.

These migrations are enabled by default, but you may want to disable them, to do so add the following before starting the SDK:

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
class YourApp : Application() {
  
  override fun onCreate() {
    super.onCreate()
    // Disable profile's migration
    Batch.disableMigration(
      EnumSet.of( 
        // Whether Batch should automatically identify logged-in user when running the SDK for the first time.
        // This mean user with a custom_user_id will be automatically attached a to a Profile and could be targeted within a Project scope.
        BatchMigration.CUSTOM_ID,  
        // Whether Batch should automatically attach current installation's data (language/region/customDataAttributes...)
        // to the User's Profile when running the SDK for the first time.
        BatchMigration.CUSTOM_DATA
      )
    )
    // Then start the sdk
    Batch.start("YOUR_API_KEY")
    registerActivityLifecycleCallbacks(BatchActivityLifecycleHelper())
  }
}
```

{% endtab %}

{% tab title="Java" %}

```java
public class YourApp extends Application {

  @Override
  public void onCreate() {
    super.onCreate();
    // Disable profile's migration
    Batch.disableMigration(
      EnumSet.of(
        // Whether Batch should automatically identify logged-in user when running the SDK for the first time.
        // This mean user with a custom_user_id will be automatically attached a to a Profile and could be targeted within a Project scope.
        BatchMigration.CUSTOM_ID,
        // Whether Batch should automatically attach current installation's data (language/region/customDataAttributes...)
        // to the User's Profile when running the SDK for the first time.
        BatchMigration.CUSTOM_DATA
      )
    );
    
    // Then start the sdk
    Batch.start("YOUR_API_KEY");
    registerActivityLifecycleCallbacks(new BatchActivityLifecycleHelper());
  }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://doc.batch.com/developer/sdk/android/profile-data/data-migration.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
